% PHsimp.m: Called by 'PG(simp)' to determine the pulse width
% This is a simple example of how to use an m-file from within SIMULINK
  
% Written by:  Jonathan Jacobs
%              November 1997  (last mod: 11/10/97)

function y = PHsimp( u )

if (abs(u)<=2)
   % calculated 3rd order fit coefficients
   y = 4.323556282341898*abs(u)^3 - 20.34608605093185*abs(u)^2 ...
     + 31.08518034195106*abs(u)^1 + 0.7583137180679862*abs(u)^0;

   % sloppy correction factors
   if abs(u)<=0.10
     y = y*0.55;
    elseif abs(u)<=0.3
     y = y*0.65;
    elseif abs(u)<=0.4
     y = y * 0.727;
    elseif abs(u)<=0.5
     y = y * 0.79;
    elseif abs(u)<=0.6
     y = y * 0.85;
    elseif abs(u)<=2.0
     y = y * 0.95;
   end

 elseif (abs(u)>2)
   % calculated 4th order fit coefficients
   y = -3.804117477724024e-005*abs(u)^4 + 5.111877410635799e-003*abs(u)^3 ...
       - 2.604783757612886e-001*abs(u)^2 + 6.537037380927728e+000*abs(u)^1 ...
       + 5.707963293679013e+000*abs(u)^0;

   %sloppy
   if abs(u)<=2.25
     y = y*0.89;
    elseif abs(u)<=2.5
     y = y*0.925;
    elseif abs(u)<=3.0
     y = y*0.95;
   end

end

if (abs(u)>=47)
   y=82.61;
end

y=y*sign(u);